<?php
$visas_ftp_host;
$visas_ftp_user;
$visas_ftp_passwd;
$visas_ftp_connection;


$file_imgs=array(
".gif"=>"/img/pic.gif",
".jpg"=>"/img/pic.gif",
".tif"=>"/img/pic.gif",
".png"=>"/img/pic.gif"
);

$file_ascii=array(".txt", ".pl", ".cgi", ".html", ".php", ".php3", ".htm", ".php4");

function get_file_type($file_name){
  return substr($file_name,strrpos($file_name,"."));
}

function file_permissions($permissions,$user,$type){
  if($user=="owner"){
    $user=0;
  }elseif($user=="group"){
    $user=1;
  }elseif($user=="others"){     
    $user=2;
  }else{
    return "";
  }
  if(!(strpos(substr($permissions,$user*3+1,3), $type)===false)){
    return "checked";
  }
  return "";
}

function convertSize($size){
  $stellen=strlen($size);
  if($stellen<2){
    return $size." Byte";
  }elseif($stellen<4){
    return round($size/1000,2)." KB";
  }elseif($stellen<7){
    return round($size/1000)." KB";
  }elseif($stellen<10){
    return round($size/1000000)." MB";
  }elseif($stellen<13){
    return round($size/1000000000)." GB";
  }else{
    return round($size/1000000000000)." TB";   
  }
}


function visas_ftp_connect($host, $user, $passwd){
  global $visas_ftp_host, $visas_ftp_user, $visas_ftp_passwd, $visas_ftp_connection;  
  $visas_ftp_host=$host;
  $visas_ftp_user=$user;
  $visas_ftp_passwd=$passwd;
  $visas_ftp_connection=ftp_connect($visas_ftp_host);
  $login_result = @ftp_login($visas_ftp_connection, $visas_ftp_user, $visas_ftp_passwd); 
  if(!$login_result){ 
    visas_ftp_close();
    fehlerausgabe("Keine FTP-Verbindung!<br> Probieren Sie es in wenigen Minuten erneut oder wenden Sie sich an den Systemadministrator!<br><br>");
    $visas_ftp_connection=0;
  }
}


function visas_ftp_list($dir){
  global $visas_ftp_connection;
  $ftp_output=ftp_rawlist($visas_ftp_connection,$dir);
  $lines=$ftp_output;
  foreach($lines as $line){
    $line=trim($line);
    if($line!=""){
      $tokens=split(" ",$line);
      foreach($tokens as $token){
        if($token!=""){
          $data[]=$token;
        }
      }
      if(count($data)>9){
        for($i=9;$i<count($data);$i++){
          $data[8].=" ".$data[$i];
        }
      }
      $files[]=array(
         "permissions"=>trim($data[0]),
         "type"=>trim($data[1]),
         "owner"=>trim($data[2]),
         "group"=>trim($data[3]),
         "size"=>trim($data[4]),
         "time"=>trim($data[5])." ".trim($data[6])." ".trim($data[7]),
         "name"=>trim($data[8])
      );
      unset($data);
    }
  }
  return $files;
}


function visas_ftp_close(){
  global $visas_ftp_connection;
  if($visas_ftp_connection){
    ftp_quit($visas_ftp_connection); 
  }
}
?>
