<?php
session_cache_limiter('private');

if(!isset($visas_level)) $visas_level="1";
$layout_dir="/usr/local/visas/public_html/layout/layout_lvl$visas_level";
if(!file_exists("$layout_dir/template.html")) $layout_dir="/usr/local/visas/public_html/layout/layout_lvl3";
if(!file_exists("$layout_dir/template.html")) $layout_dir="/usr/local/visas/public_html/layout/";
if(!isset($visas_allow_access)) $visas_allow_access=false;

if(file_exists("$layout_dir/visas.php")){
  include("$layout_dir/visas.php");
}

if(empty($title)){
  $title="Virtual Server Administration System (ViSAS)";
}

function make_layout($action){
 global $template1, $template2;
 if(!empty($template1) && !empty($template2)){
  if($action=="start"){
   echo "$template1";
  }else{
   echo "$template2";
   require("/usr/local/visas/lib/visas_close.inc.php");
  }
 }  
}

if(!$visas_allow_access){
  $menu=new Menu("","");
  $menu->add_item("Login","$SCRIPT_NAME");
  $visas_layout_lvl=$visas_level;
  $headline_site="Login";
  $visas_help_id='loginhelp';
}

if(file_exists("$layout_dir") && file_exists("$layout_dir/template.html") && !empty($menu)){
 if(empty($template1) && empty($template2)){
  $menu->set_curr_menu($curr_menu);
  $menu->curr_path=$curr_path;

  $fd=fopen("$layout_dir/template.html","r");
  while(!feof($fd)){
    $line=fgets($fd, 4097);
    $template=$template.$line;
  }
  fclose($fd);

  $start=strpos($template,"[MENU]");
  $end=strpos($template,"[/MENU]");
  $menu_str=substr($template,$start+strlen("[MENU]"),$end-$start-strlen("[MENU]"));
  $template=substr($template,0,$start)."[INS_MENU]".substr($template,$end+strlen("[/MENU]"));

  $start=strpos($template,"[SUBMENU]");
  $end=strpos($template,"[/SUBMENU]");
  $submenu=substr($template,$start+strlen("[SUBMENU]"),$end-$start-strlen("[SUBMENU]"));
  $template=substr($template,0,$start).substr($template,$end+strlen("[/SUBMENU]"));

  $start=strpos($template,"[HELP]");
  $end=strpos($template,"[/HELP]");
  $help_layout_str="";
  if($visas_help=='show'){
    $help_layout_str=substr($template,$start+strlen("[HELP]"),$end-$start-strlen("[HELP]"));
    @include("/usr/local/visas/lib/visas_help_data.inc.php");
    $visas_help_var="visas_help_$visas_help_id";
    $help_layout_str=str_replace("[HELP_TEXT]",$$visas_help_var,$help_layout_str);
    $help_layout_str=str_replace("[HELP_ID]",$visas_help_id,$help_layout_str);
  }
  $template=substr($template,0,$start).$help_layout_str.substr($template,$end+strlen("[/HELP]"));

  $start=strpos($template,"[HELP_LINK]");
  $end=strpos($template,"[/HELP_LINK]");
  $help_link_layout_str="";
  if(isset($visas_help_id)){
    $help_link_layout_str=substr($template,$start+strlen("[HELP_LINK]"),$end-$start-strlen("[HELP_LINK]"));
    $help_link_layout_str=str_replace("[HELP_LINK_URL]","$SCRIPT_NAME?visas_help=show&$visas_help_query",$help_link_layout_str);
  }
  $template=substr($template,0,$start).$help_link_layout_str.substr($template,$end+strlen("[/HELP_LINK]"));

  $menu->set_menu_html($menu_str);
  $menu->set_submenu_html($submenu);
  $template=str_replace("[INS_MENU]",$menu->make_html(),$template);

  $template=str_replace("[HEADLINE_LEVEL]",$headline_level,$template);
  $template=str_replace("[HEADLINE_SITE]",$headline_site,$template);
  $template=str_replace("[TITLE]",$title,$template);
  
  $start=strpos($template,"[MAIN]");
  $template1=substr($template,0,$start);
  $template2=substr($template,$start+strlen("[MAIN]"));
 }
}else{
  die("<h2>ViSAS - Fehler:</h2><b>ViSAS konnte nicht alle Dateien fr die Layout-Templates finden:<br><ul><li>$layout_dir/template.html</li><li>\$menu</li></ul></b>");
}

if(!$visas_allow_access){
  make_layout("start");

  echo "<p><b>$visas_login_msg</b></p>";
    
  echo "<form action='$SCRIPT_NAME' method='POST' name='login_form'>";
  echo "<table width=100% height=100% border=0 cellpadding=20 cellspacing=10><tr><td valign=top>";
  echo "<table align=left width=30% $table_main>";
  #echo "<tr><td colspan=2 $td_head1>Login:</td></tr>";
  echo "<tr><td $td_head1>Loginname:</td><td><input type='input' name='new_visas_login_user' value='$new_visas_login_user'></td></tr>";
  echo "<tr><td $td_head1>Password:</td><td><input type='password' name='new_visas_login_passwd'></td></tr>";
  echo "<tr><td align=right colspan=2 $td_head1><input type=image SRC='/img/go.gif' border='0' name='gif' align='absbottom'></td></tr>";
  echo "</table>";
  echo "</td></tr></table>";
  echo "</form>";
  echo "<script language='JavaScript'><!--\n";
  if(!empty($new_visas_login_user)) echo "document.login_form.new_visas_login_passwd.focus();";
  else echo "document.login_form.new_visas_login_user.focus();";
  echo "\n//--></script>";
  
  make_layout("end");
  die();
}
?>
