<?php
$visas_block_errors=false;
function userErrorHandler ($errno, $errmsg, $filename, $linenum, $vars){
  global $dbconnect;
  $errortype = array (
                1   =>  "Error",
                2   =>  "Warning",
                4   =>  "Parsing Error",
                8   =>  "Notice",
                16  =>  "Core Error",
                32  =>  "Core Warning",
                64  =>  "Compile Error",
                128 =>  "Compile Warning",
                256 =>  "User Error",
                512 =>  "User Warning",
                1024=>  "User Notice"
                );
  if (error_reporting() && !$visas_block_errors){
    if($errno==2 
         && ( !(strpos(strtolower($errmsg),"mysql")===false) 
                  || !(strpos(strtolower($errmsg),"access denied for user:")===false)
            ) 
         && !$dbconnect
      ){
      $fehler="Fehler bei der Verbindung zur MySQL-Datenbank!<br>";
      $fehler.="Lsungsmglichkeiten:";
      $fehler.="<ul>";
      $fp=@fsockopen("localhost",3306,$fnr,$ftext,4);  
      if(!$fp) $fehler.="<li><a href='/serveradminlevel/system_scan.php'>MySQL-Datenbankserver starten</a></li>";
      $fehler.="<li><a href='/serveradminlevel/grundkonfiguration.php#systemconfig'>Konfiguration bearbeiten</a></li>";
      $fehler.="</ul>";
      $fehler.="<font size=1 class='error_type'><u>Details:</u> $errortype[$errno]: $errmsg <br>(line $linenum in $filename)</font>";
      fehlerausgabe($fehler);
      $visas_block_errors=true;
    }elseif($errno==2 || $errno==1 || $errno==4){
        echo "<p><b>ViSAS-Fehler:</b> Ein Fehler ist aufgetreten.<br>";
        echo "<font size=1 class='error_type'>Details: $errortype[$errno]: $errmsg <br>(line $linenum in $filename)</font>";
        echo "</p>\n";
    }elseif($errno==E_USER_ERROR){
        echo "<p><b>ViSAS-Fehler:</b> Ein Fehler ist aufgetreten.<br>";
        echo "<font size=1 class='error_type'>$errmsg</font>";
        echo "</p>\n";
    }
  }
}
$old_error_handler = set_error_handler("userErrorHandler");



function wtc ($line){
  $fp = fopen('/usr/local/visas/befehle/liste', 'a+');
  flock($fp, 2) or die("Kann die Datei nicht locken.");
  fwrite($fp, "$line \n");
  fclose($fp);
}

function check_if_user_exist($tocheckuser) {
 $fd = fopen ("/etc/passwd", "r");
 while (!feof($fd)) {
  $buffer = fgets($fd, 4096);
  list($linuxuser, $muell) = split (":",$buffer,2);
  if ($linuxuser == $tocheckuser) {
   return true;
  }
 }
 fclose ($fd);

 return false;
}

function visas_shell($cmd){  
  $buffer=`$cmd`;
  return trim($buffer);
}

function check_sonderzeichen($str){
  if(strlen($str)>3 && ereg("^([a-zA-Z0-9]{4,})$",$str)){
    return true;
  }else{
    return false;
  }
}


function domainfehler ($layout=false){
  fehlerausgabe_hback("Diese Domain ist bereits angemeldet!",$layout);
}

function systemdomainfehler ($layout=false){
  fehlerausgabe_hback("Diese Domain ist der Systemadministration vorbehalten und kann nicht angemeldet werden!",$layout);
}

function eingabefehler($fehler,$layout=false){
  fehlerausgabe_hback($fehler,$layout);
}

function accountfehlerausgabe ($fehler,$layout=false){
  fehlerausgabe_hback($fehler."<br>Bitte wenden Sie sich an Ihren Provider, um Ihren Kundenaccount zu erweitern.",$layout);
}  

function authfehlerausgabe($layout=false){
  fehlerausgabe_hback("Sie sind f&uuml;r diese Domain nicht authorisiert.",$layout);
}

function fehlerausgabe_hback($fehler, $layout=false){
  fehlerausgabe($fehler."<br><a href='javascript:window.history.back()'>[Korrigieren]</a>",$layout);
}

function fehlerausgabe ($fehler, $layout=false){
  global $table_main, $td_head1, $curr_path;
  if($layout) make_layout("start");
  include($curr_path."fehler_header.php");
  echo "$fehler";
  include($curr_path."fehler_footer.php");
  if($layout) make_layout("end");
  die ();
}



function pruefe_n ($text,$fehlertext){
  if (($text=="") Or (!is_numeric($text))) eingabefehler ($fehlertext);
}

function umlaute_ersetzen($name){
  $umlaute=array("","","","");
  $replace=array("ae","ue","oe","ss");
  for($i=0;$i<count($umlaute);$i++){
    $name=eregi_replace($umlaute[$i],$replace[$i],$name);
  }
  return $name;
}

function check_phone(&$phone){
  if(ereg("^\+[0-9]{1,2} [0-9 ]{4,}$",$phone)){
    $phone=substr($phone,0,4).ereg_replace(" ","",substr($phone,4));
    return 0;
  }else{
    return 1;
  }
}

function illegal_email($name){
  if(ereg("^[a-zA-Z0-9][a-zA-Z0-9\.:\-]*[a-zA-Z0-9]@[a-zA-Z0-9][a-zA-Z0-9\.-]*[a-zA-Z0-9]\.[a-zA-Z]{1,}$",$name)){
    return false;
  }else{
    return true;
  }
}

function domain_pruefen ($t){
$result=0;
for ($i = 0; $i<strlen($t); $i++){
 if ((ord($t[$i])<48) And (ord($t[$i])!==45) And (ord($t[$i])!==46)) $result=1;
 if ((ord($t[$i])>57) And (ord($t[$i])<97) And (ord($t[$i])!==95)) $result=1;
 if (ord($t[$i])>122) $result=1;
 if (ord($t[$i])==95) $result=1;
  if ($t[$i]=='_') $result=1;
 if ($result==1) eingabefehler ('Eine Domain darf nur Buchstaben, Zahlen und den Bindestrich "-" enthalten.');
}
}

function visas_load_url($url){
  $fd=@fopen("$url",'r');
  $data='';
  if($fd){
    while(!feof($fd)){
      $line=fgets($fd,4067);
      $data.=$line;
    }
    fclose($fd);
  }else{
    trigger_error("Die Datei $url kann nicht gelesen werden!",E_USER_ERROR);
    $data="";
  }
  return $data;
}

function visas_version(){
  $data=@visas_load_url('/etc/ViSAS-release');
  $lines=split("\n",$data);
  $version=trim($lines[0]);
  return $version;
}

function get_linux_version(){
  $linux_version="";
  if(file_exists("/etc/redhat-release")){
    $linux_version=textdatei_lesen("/etc/redhat-release"); 
  }elseif(file_exists("/etc/SuSE-release")){
    $data=@visas_load_url('/etc/SuSE-release');
    $lines=split("\n",$data);
    $linux_version=trim($lines[0]);
  }elseif(file_exists("/etc/debian_version")){
    $linux_version="Debian GNU/Linux version ".trim(textdatei_lesen("/etc/debian_version"));
  }
  return $linux_version;
}

function textdatei_schreiben ($datei,$text){
  $fd = @fopen($datei, "w");
  if($fd){
    fputs($fd,$text);
    fclose($fd);
  }else{
    trigger_error("Die Datei $datei kann nicht zum Schreiben geffnet werden!",E_USER_ERROR);
  }
}

function textdatei_lesen ($datei){
  return visas_load_url($datei);
}


function loginnamen_generieren (){
  srand ((double) microtime() * 1000000);
  $t=chr(rand (97, 117));
  if (($t=="j") or ($t=="i") or ($t=="o") or ($t=="l")) $t="z";
  $t.=date ("dmyhis");
  $z=rand (1, 98);
  $t.="$z";
  return $t;
}

function password_generieren ()
{
srand ((double) microtime() * 1000000);
 
$t="";
 
for ($i = 1; $i <= 5; $i++)
{
$z=chr(rand (97, 118));
if (($z=="j") or ($z=="i") or ($z=="o") or ($z=="l")) $z="z";
$t.="$z";
}
 
$z=rand (1, 9999);
$t.="$z";
return $t;
}


if(!function_exists("mysql_create_db")){
  function mysql_create_db($datenbankname,$link_identifier=0){
    global $dbconnect;
    if($link_identifier!=0) $dbconnect=$link_identifier;
    if(mysql_query("create database $datenbankname",$dbconnect)) return true;
    else return false;
  }
}
if(!function_exists("mysql_drop_db")){
  function mysql_drop_db($datenbankname,$link_identifier=0){
    global $dbconnect;
    if($link_identifier!=0) $dbconnect=$link_identifier;
    if(mysql_query("drop database $datenbankname",$dbconnect)) return true;
    else return false;
  }
}
    

$visas_parse_page_start_ts=microtime();

@$fd = fopen ('/usr/local/visas/etc/visas.conf', "r");
if(!$fd){
  die("<h2>ViSAS - Fehler:</h2><b>ViSAS konnte die Datei /usr/local/visas/etc/visas.conf nicht lesen!<br></b>");
}
while (!feof ($fd)) {
    $buffer = fgetss($fd, 4096);
$buffer.=trim(buffer);
$p=strpos($buffer,'=');
$pieces[0]=substr ($buffer, 0,$p); 
$p++;
$pieces[1]=trim(substr ($buffer,$p));
$pieces2=explode (chr(10),$pieces[1]);
$pieces[1]=$pieces2[0];
if ($pieces[0]=='MASCHINE') $maschine=$pieces[1];
if ($pieces[0]=='FRONTPAGE') $frontpage=$pieces[1];
if ($pieces[0]=='HAUPTBENUTZER_GRUPPE') $hauptbenutzer_gruppe=$pieces[1];
if ($pieces[0]=='VISASNAME') $visas_name=$pieces[1];
if ($pieces[0]=='VISASVORNAME') $visas_vorname=$pieces[1];
if ($pieces[0]=='FIRMENNAME') $firmenname=$pieces[1];
if ($pieces[0]=='FIRMENSTRASSE') $firmenstrasse=$pieces[1];
if ($pieces[0]=='FIRMENPLZ') $firmenplz=$pieces[1];
if ($pieces[0]=='FIRMENORT') $firmenort=$pieces[1];
if ($pieces[0]=='FIRMENSUPPORTEMAIL') $firmensupportemail=$pieces[1];
if ($pieces[0]=='FIRMENSUPPORTHOTLINE') $firmensupporthotline=$pieces[1];
if ($pieces[0]=='FIRMENFAXNUMMER') $firmenfaxnummer=$pieces[1];
if ($pieces[0]=='DENICHANDLE') $denichandle=$pieces[1];
if ($pieces[0]=='COCOHANDLE') $cocohandle=$pieces[1];
if ($pieces[0]=='INFOHANDLE') $infohandle=$pieces[1];
if ($pieces[0]=='BIZHANDLE') $bizhandle=$pieces[1];
if ($pieces[0]=='FILESYSTEM') $filesystem=$pieces[1];
if ($pieces[0]=='HARDDISK') $harddisk=$pieces[1];
if ($pieces[0]=='NAMESERVER1') $nameserver1=$pieces[1];
if ($pieces[0]=='NAMESERVER2') $nameserver2=$pieces[1];
if ($pieces[0]=='NAMESERVER1PFAD') $nameserver1pfad=$pieces[1];                      
if ($pieces[0]=='NAMESERVER2PFAD') $nameserver2pfad=$pieces[1]; 
if ($pieces[0]=='CNONAMESERVER1HANDLE') $cnonameserver1handle=$pieces[1];
if ($pieces[0]=='CNONAMESERVER2HANDLE') $cnonameserver2handle=$pieces[1]; 
if ($pieces[0]=='VISASABSENDERNAME') $visasabsendername=$pieces[1];
if ($pieces[0]=='VISASABSENDEREMAIL') $visasabsenderemail=$pieces[1];
if ($pieces[0]=='DOMAINPROVIDER') $domainprovider=$pieces[1];
if ($pieces[0]=='DOMREGEMAIL') $domregemail=$pieces[1];
if ($pieces[0]=='CNODOMREGEMAIL') $cnodomregemail=$pieces[1]; 
if ($pieces[0]=='BESTELLEMAIL') $bestellemail=$pieces[1];
if ($pieces[0]=='HOSTMASTEREMAIL') $hostmasteremail=$pieces[1];
if ($pieces[0]=='RIPEHANDLEEMAIL') $ripehandleemail=$pieces[1];
if ($pieces[0]=='ROOTPASSWORDMYSQL') $rootpasswordmysql=$pieces[1];
if ($pieces[0]=='FIBUEMAIL') $fibuemail=$pieces[1];
if ($pieces[0]=='SERVERHOSTNAME') $serverhostname=$pieces[1];
if ($pieces[0]=='DOMAINORDERXUSER') $domainorder_xuser=$pieces[1];
if ($pieces[0]=='DOMAINORDERXPASS') $domainorder_xpass=$pieces[1];
if ($pieces[0]=='APACHE_VERSION') $apache_version=$pieces[1];
}

fclose ($fd);

function checkauth($domain, $ftploginname) {
 global $dbconnect;

 $query = "select * from level3kunden where domain = \"$domain\"";
 $result = mysql_db_query("visas",$query,$dbconnect);
 $row = mysql_fetch_array($result);

 if ($row[ftploginname] == $ftploginname) {
  return true;
 } else {
  return false;
 }
}



$dbconnect = @mysql_connect ("localhost", "root",$rootpasswordmysql);
@mysql_select_db("visas",$dbconnect);

?>
