<?php

function getvpopmailpath ($vpopmail_dir,$domain)
{
$output=visas_shell("$vpopmail_dir/bin/vdominfo $domain");
$output=split("\n",$output);

$pv=trim(substr ($output[3],5));
return $pv;
}


$vpopmail_dir="/home/vpopmail";
$domain=$l3domain;
$vpopmail_domain_dir=getvpopmailpath ($vpopmail_dir,$domain);
$ezmlm_dir="/usr/local/bin/ezmlm";


if($confirm=='Abbrechen' || $confirm=='Nein'){
  $action="";
}

if(!is_dir($vpopmail_domain_dir)){
  accountfehlerausgabe2("Die Domain ist nicht korrekt eingerichtet!");
}


if(!function_exists("vpopmail_add_user")){
 function vpopmail_add_user($name,$domain,$passwd){
   global $visas_vpopmail_error, $vpopmail_dir;
   $visas_vpopmail_error=visas_shell("$vpopmail_dir/bin/vadduser $name@$domain $passwd");
 }

 function vpopmail_error(){
   global $visas_vpopmail_error, $vpopmail_dir;
   if($visas_vpopmail_error=="") $visas_vpopmail_error='Success';
   return $visas_vpopmail_error;
 }

 function vpopmail_set_user_quota ($name,$domain,$mailquota){
   global $visas_vpopmail_error, $vpopmail_dir;
   $visas_vpopmail_error=visas_shell("$vpopmail_dir/bin/vsetuserquota $name@$domain $mailquota");
 }

 function vpopmail_passwd($name, $domain, $passwd){
   global $visas_vpopmail_error, $vpopmail_dir;
   $visas_vpopmail_error=visas_shell("$vpopmail_dir/bin/vpasswd $name@$domain $passwd");
 }

 function vpopmail_del_user($name,$domain){
   global $visas_vpopmail_error, $vpopmail_dir;
   $visas_vpopmail_error=visas_shell("$vpopmail_dir/bin/vdeluser $name@$domain");
 }
}

function accountfehlerausgabe2($fehler)
{
global $table_main, $td_head1;
include ("fehler_header.php");
echo $fehler;
echo "<br>Bitte wenden Sie sich an Ihren Provider, um Ihren Kundenaccount
zu erweitern.";
echo '<br><a href="javascript:window.history.back ()">[Korrigieren]</a>';
include ('fehler_footer.php');
die ();
}

function parseVpasswd(){
  global $vpopmail_domain_dir,$gesamtquota;
  $vpasswd_str=textdatei_lesen("$vpopmail_domain_dir/vpasswd");
  $vpasswd_lines=split("\n",$vpasswd_str);
  $gesamtquota=0;
  for($i=0;$i<count($vpasswd_lines);$i++){
    $vpasswd_line=$vpasswd_lines[$i];
    if(trim($vpasswd_line)!=""){
      list($name,$crypt_passwd,$param3,$param4,$comment,$dir,$quota,$passwd)=split(":",$vpasswd_line);
      $vpasswd[$i][name]=$name;
      $vpasswd[$i][crypt_passwd]=$crypt_passwd;
      $vpasswd[$i][param3]=$param3;
      $vpasswd[$i][param4]=$param4;
      $vpasswd[$i][comment]=$comment;
      $vpasswd[$i][dir]=$dir;
      $vpasswd[$i][quota]=$quota;
      $vpasswd[$i][passwd]="";
	$gesamtquota=$gesamtquota+$quota;
    }
  }  
  $gesamtquota=$gesamtquota/1000000;
  $vpasswd=vsort_list($vpasswd,'name');
  return $vpasswd;
}

function vsort_list($carray, $index){
  if(!isset($carray[0][$index])) $index=0;

  if(is_array($carray) && is_array($carray[0])){
  for($a=0;$a<count($carray);$a++){
    $max_index=$a;
    for($b=$a;$b<count($carray);$b++){
      if($carray[$b][$index]<$carray[$max_index][$index]){
        $max_index=$b;
      }
    }
    $old_a=$carray[$a];
    $new_a=$carray[$max_index];
    $carray[$a]=$new_a;
    $carray[$max_index]=$old_a;
  }
  }
  return $carray;
}

function deleteSMTPaccount ($popaccount)
{
$newtext='';
$vpasswd_str=textdatei_lesen("/etc/poppasswd");
  $vpasswd_lines=split("\n",$vpasswd_str);
 for($i=0;$i<count($vpasswd_lines);$i++)
{
   $vpasswd_line=$vpasswd_lines[$i];
    if(trim($vpasswd_line)!=""){
      list($name,$passwd)=split(":",$vpasswd_line);
      if ($name==$popaccount) $vpasswd_lines[$i]=''; 
      }
if ($vpasswd_lines[$i]!='') $newtext=$newtext.$vpasswd_lines[$i]."\n";
}
textdatei_schreiben("/etc/poppasswd",$newtext);
}

function changeSMTPpasswd($popaccount,$vpasswd)
{
  $vpasswd_str=textdatei_lesen("/etc/poppasswd");
  $vpasswd_lines=split("\n",$vpasswd_str);
  for($i=0;$i<count($vpasswd_lines);$i++)
{
    $vpasswd_line=$vpasswd_lines[$i];
    if(trim($vpasswd_line)!=""){
      list($name,$passwd)=split(":",$vpasswd_line);
      if ($name==$popaccount)
                {
                $vpasswd_lines[$i]="$popaccount:$vpasswd";
                }
    }
}   
$vpasswd_str='';
for($i=0;$i<count($vpasswd_lines);$i++){
$vpasswd_str=$vpasswd_str.$vpasswd_lines[$i]."\n";
}  
textdatei_schreiben("/etc/poppasswd",$vpasswd_str);
 
}



function saveSMTPpasswd ($popaccount,$vpasswd)
{
$text=textdatei_lesen ("/etc/poppasswd");
$text=trim($text)."\n".$popaccount.":".$vpasswd."\n";
textdatei_schreiben ("/etc/poppasswd",$text);
}


function saveVpasswd($vpasswd){
  global $vpopmail_domain_dir;
  foreach($vpasswd as $line){
    foreach($line as $arg){
      if(array_search($arg,$line)=="passwd") continue;
      $text=$text."$arg:";
    }
    $text=substr($text,0,strlen($text)-1)."\n";
  }
  textdatei_schreiben("$vpopmail_domain_dir/vpasswd",$text);
}   


function vpopmail_set_user_comment($user,$comment){
  $vpasswd=parseVpasswd();
  for($i=0;$i<count($vpasswd);$i++){
    if($vpasswd[$i][name]==$user){
      $vpasswd[$i][comment]=$comment;
    }
  }
  saveVpasswd($vpasswd);
}

function vpopmail_get_forwarders($user){
  global $vpopmail_domain_dir;
  $handle=opendir ($vpopmail_domain_dir);
  while (false !== ($file = readdir ($handle))){
    if(@is_file("$vpopmail_domain_dir/$file") && !(strpos($file,".qmail-")===false)){
      $name=substr($file,strlen(".qmail-"));
      unset($forwarder);
      if($name!="default"){
        $fd=fopen("$vpopmail_domain_dir/$file","r");
        $ok=1;
        $name=ereg_replace(':', '.', $name);
        $forwarder[]=$name;          
        while(!feof($fd)){
          $line=fgets($fd,4096);
          if(trim($line)!=""){
            if(strpos($line,"&")==0 && !(strpos($line,"&")===false) && !(strpos($line,"@")===false)){
              $forwarder[]=substr(trim($line),1);
            }elseif(@is_dir(trim($line))){
              $forwarder[]=substr(trim($line),strlen("$vpopmail_domain_dir/"),strpos($line,"/",strlen("$vpopmail_domain_dir/"))-strlen("$vpopmail_domain_dir/"));
            }else{
              $ok=0;
              break;
            }
          }
        }
        if($ok==1){
          $forwarders[]=$forwarder;
        }
        fclose($fd);
      }
    }
  }
  closedir($handle);
  $forwarders=vsort_list($forwarders,'name');
  return($forwarders);
}


function vpopmail_get_robots($user){
  global $vpopmail_domain_dir, $vpopmail_dir;
  $handle=opendir ($vpopmail_domain_dir);
  while (false !== ($file = readdir ($handle))){
    if(@is_file("$vpopmail_domain_dir/$file") && !(strpos($file,".qmail-")===false)){
      $name=substr($file,strlen(".qmail-"));
      unset($robot);
      if($name!="default"){
        $fd=fopen("$vpopmail_domain_dir/$file","r");
        $robot[]=$name;
        while(!feof($fd)){
          $line=fgets($fd,4096);
          if(trim($line)!=""){
            if(!(strpos($line,"autorespond")===false)){
              $params=split(" ",$line);
              $ok=1;
              $robot[]=$params[3];
            }elseif(!(strpos($line,"&")===false)){
              $robot[]=substr(trim($line),1);
            }else{
              $ok=0;
              break;
            }
          }
        }
        if($ok==1){
          $robots[]=$robot;
        }
        fclose($fd);
      }
    }
  }
  closedir($handle);
  $robots=vsort_list($robots,'name');
  return($robots);
}


function ezmlm_get_mlists($user){
  global $vpopmail_domain_dir, $vpopmail_dir;
  $handle=opendir ($vpopmail_domain_dir);
  while (false !== ($file = readdir ($handle))){
    if(@is_link("$vpopmail_domain_dir/$file") && !(strpos($file,".qmail-")===false)){
      $name=substr($file,strlen(".qmail-"));
      if(strpos($name,"-owner")===false && strpos($name,"-return-default")===false && strpos($name,"-default")===false){              
        $ok=1;
        $mls[]=$name;
      }   
    }       
  }           
  closedir($handle);
  if(is_array($mls)) sort($mls);
  return($mls);
} 

function ezmlm_get_abonents($user, $mlist){
  global $ezmlm_dir, $vpopmail_domain_dir, $domain;
//  $dir="$vpopmail_domain_dir/".strtoupper($mlist);
$dir="$vpopmail_domain_dir/".$mlist;
  @$abonents_str=`$ezmlm_dir/ezmlm-list $dir`;
  $abonents=split("\n", $abonents_str);
  return($abonents);
}


function vpopmail_get_default($user){
  global $ezmlm_dir, $vpopmail_domain_dir, $domain;
  $fd=fopen("$vpopmail_domain_dir/.qmail-default","r");
  while(!feof($fd)){
    $line=fgets($fd,4096);
    if(trim($line)!=""){
      $parts=split(" ", $line);
      $type=trim($parts[3]);
#      if($parts[3]=="bounce-no-mailbox"){
#        $type="bounce-no-mailbox";
#      }elseif($parts[3]=="delete"){
#        $type="delete";
#      }elseif(is_dir($parts[3])){
#        $type="$parts[3]";
#      }elseif(!(strpos($parts[3],"@")===false)){
#        $type="$parts[3]";
#      }
    }
  }
  fclose($fd);
  return $type;
}

?>
