<?php
$headline_site="Hilfe - Eigene Nameserver (optional)";
$curr_menu="Hilfe";

require("menu_main.inc.php");
make_layout("start");
?>

<h3>Prinzip der automatischen Nameserverwaltung:</h3>

<p>
<h4>Konstellation:</h4>
Primary Nameserver auf der gleichen Maschine<br>
Secondary Nameserver auf einer anderen Maschine<br>
</p>

<br><br>

<p>
<h4>Prinzip:</h4>
Bei einer Domainbestellung bzw. KK-Beauftragung werden automatisch die Nameserver eingerichtet.<br>
Bei einer Domainlschung wird die Zone aus den Nameservern wieder entfernt.<br>
</p>

<br><br>
 
<p>
<h4>Schritt 1: PRIMARY NAMESERVER:</h4>
Alle relevanten Daten liegen im Verzeichnis /etc/zonen/<br>
<br>
In der /etc/named.conf findet sich folgender Eintrag:<br>
include "/etc/zonen/hosts";<br>
<br>
Die hosts-Datei wird durch die Nameserverscripte bearbeitet.<br>
<br>
beispielhafter Auszug aus /etc/zonen/hosts:<br>
<br>
<pre>
-----------------------------------------------
zone "i-3.de" {
type master; 
file "/etc/zonen/i-3.de.hosts";
};

zone "i3test.de" { 
type master;
file "/etc/zonen/i3test.de.hosts"; 
}; 

zone "visas.de" { 
type master;
file "/etc/zonen/visas.de.hosts"; 
};
-----------------------------------------------
</pre>
Die Zonendateien, z.B. /etc/zonen/visas.de.hosts werden durch die Nameserverscripte angelegt.<br>
</p>

<br><br>

<p>
<h4>Schritt 2: SECONDARY NAMESERVER:</h4>
Den Secondary nameserver sollten Sie genauso konfigurieren und das Verzeichnis /etc/zonen z.B. unter 
/mnt/secondarynameserver mounten.<br>
</p>

<br><br>

<p>
<h4>Schritt 3: ViSAS Konfiguration:</h4>
Fllen Sie nun in der Grundkonfiguration folgende Felder aus:<br>
1. Nameserver und 2. Nameserver<br>
1. Nameserver und 2. Nameserver (Verzeichnis der Host- und Zonendateien): 
Fr die oben beschriebene Konfiguration wren das: /etc/zonen und /mnt/secondarynameserver<br>
<br>
Ggf. auch die Emailgateway-Dateien editieren: Z.B. an den beschrieben Stellen die Eintrge mit "//" ein- bzw. 
auskommentieren.<br>
</p>

<br><br>

<p>
<h4>Nameserverscripte:</h4>
Sie knnen die Nameserver auch direkt ber die Shell bearbeiten:<br>
Beispiele:<br>
<br>
Anlage eines neuen Eintrags:<br>
<pre>
new_zone i-3.de 80.242.137.99
</pre>
nderung der IP-Adresse eines Eintrags:<br>
<pre>
zone_update i-3.de 80.242.137.101
</pre>
Lschen eines Eintrags:<br>
<pre>
delete_zone i-3.de 
</pre>
</p>

<?php
make_layout("end");
?>
